EA_Config = { DoAlertSound, AlertSound, AlertSoundValue, LockFrame, ShowFrame, ShowFlash, ShowTimer };

function EventAlert_OnLoad(self)
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");

    this:RegisterEvent("PLAYER_LOGIN");
    this:RegisterEvent("PLAYER_ENTERING_WORLD");
    this:RegisterEvent("VARIABLES_LOADED");
    this:RegisterEvent("PLAYER_DEAD");

    EA_Frame:Hide();

	tinsert(UISpecialFrames,"EA_Frame");

    SlashCmdList["EVENTALERT"] = EventAlert_SlashHandler;
    SLASH_EVENTALERT1 = "/eventalert";
    SLASH_EVENTALERT2 = "/ea";

end


function EventAlert_OnEvent(event)

	if event == "VARIABLES_LOADED" then

        if EA_Config.AlertSound == nil then EA_Config.AlertSound = "Sound\\Spells\\ShaysBell.wav" end;
        if EA_Config.AlertSoundValue == nil then EA_Config.AlertSoundValue = 1 end;
        if EA_Config.DoAlertSound == nil then EA_Config.DoAlertSound = true end;
		if EA_Config.LockFrame == nil then EA_Config.LockFrame = true end;
   		if EA_Config.ShowFrame == nil then EA_Config.ShowFrame = true end;
  		if EA_Config.ShowName == nil then EA_Config.ShowName = true end;
  		if EA_Config.ShowFlash == nil then EA_Config.ShowFlash = false end;
        if EA_Config.ShowTimer == nil then EA_Config.ShowTimer = true end;
        if EA_Config.IconSize == nil then EA_Config.IconSize = 60 end;
        if EA_Config.ChangeTimer == nil then EA_Config.ChangeTimer = false end;

        if (EA_Position == nil) then
			EA_Position = { Anchor, xLoc, yLoc };

			if EA_Position.Anchor == nil then EA_Position.Anchor = "CENTER" end;
			if EA_Position.xLoc == nil then EA_Position.xLoc = 0 end;
			if EA_Position.yLoc == nil then EA_Position.yLoc = 0 end;
        end

		_, playerClass = UnitClass("player");
        EventAlert_LoadTextArray();
		EventAlert_LoadSpellArray();

        EventAlert_Options_Init();
	end

	if(event == "COMBAT_LOG_EVENT_UNFILTERED") then

		local eventType = arg2;

        if (eventType == "SPELL_AURA_APPLIED" or eventType == "SPELL_AURA_APPLIED_DOSE") then
        	if (arg7 == UnitName("player")) then

	        	if (arg9 ~= 53817) then
					if (EA_Items[playerClass][arg9] or EA_Items["Other"][arg9]) then
        	           	spellID = arg9;
		            	_, _, gsiIcon, _, _, _, _, _, _ = GetSpellInfo(arg9);

						EventAlert_DoAlert();
                end

	        	elseif (arg9 == 53817) then
	            	if (arg13 == 5) then
	                	spellID = arg9;
		            	_, _, gsiIcon, _, _, _, _, _, _ = GetSpellInfo(arg9);

						EventAlert_DoAlert();
	                end
	            end
    	   	end
	    end

        if(eventType == "SPELL_AURA_REMOVED" and arg7 == UnitName("player")) then
			if (EA_Items[playerClass][arg9] or EA_Items["Other"][arg9]) then
           		EA_Frame:Hide();
        	end
		end
	end

    if(event == "PLAYER_DEAD" or event == "PLAYER_ENTERING_WORLD") then
        EA_Frame:Hide();
    end

end


function EventAlert_OnUpdate()

    if (spellID == nil) then
    	-- Do Nothing.
    else
		if (EA_Config.ShowTimer == true) then
		    local name, rank = GetSpellInfo(spellID);
			local _,_,_,_,_,_,expirationTime,_,_ = UnitAura("player", name, rank)

	        if not expirationTime then
	        	return
	        end

			local time = 0;

			time = time + expirationTime;
			currentTime = GetTime();
		    timeLeft = expirationTime - currentTime;

	        if timeLeft > 0 then
				if (EA_Config.ChangeTimer == true) then
                    timerFontSize = 28;
                    EA_Alert_Timer:ClearAllPoints();
                    EA_Alert_Timer:SetPoint("CENTER", 0, 0);
        	    else
               		timerFontSize = 18;
                    EA_Alert_Timer:ClearAllPoints();
                    EA_Alert_Timer:SetPoint("TOP", 0, 20);
            	end

                EA_Alert_Timer:SetFont("Fonts\\\FRIZQT__.TTF", timerFontSize, "OUTLINE");
                EA_Alert_Timer:SetFormattedText("%d", timeLeft);
            else
		    	EA_Alert_Timer:SetText("");
		    end
		else
		   	EA_Alert_Timer:SetText("");
		end
    end
end


function EventAlert_DoAlert(event)

	if (EA_Config.ShowFrame == true) then

    	EA_Frame:SetWidth(EA_Config.IconSize);
        EA_Frame:SetHeight(EA_Config.IconSize);
        EA_Frame:SetPoint(EA_Position.Anchor, EA_Position.xLoc, EA_Position.yLoc);

		EA_Frame:SetBackdrop({bgFile = gsiIcon});

	    if (EA_Config.ShowName == true) then
    		EA_Alert_Name:SetText(arg10);
	    else
    		EA_Alert_Name:SetText("");
		end

	    EA_Frame:Show();

	end

	if (EA_Config.ShowFlash == true) then
	   UIFrameFadeIn(LowHealthFrame, 1, 0, 1);
	   UIFrameFadeOut(LowHealthFrame, 2, 1, 0);
	end

	if (EA_Config.DoAlertSound == true) then
	   PlaySoundFile(EA_Config.AlertSound);
	end
end



function EventAlert_SlashHandler(msg)

    msg = string.lower(msg);

	if (msg == "options" or msg == "opt") then

    	if not EA_Options_Frame:IsVisible() then
            ShowUIPanel(EA_Options_Frame);
	    else
	        HideUIPanel(EA_Options_Frame);
	    end

    else
        DEFAULT_CHAT_FRAME:AddMessage("EventAlert commands (/eventalert or /ea):");
        DEFAULT_CHAT_FRAME:AddMessage("/ea options (/ea opt) - Toggle the options window on or off");
    end

end


function EventAlert_MouseDown(button)
    if button == "LeftButton" and EA_Config.LockFrame == false then
        EA_Frame:StartMoving();
    end
end

function EventAlert_MouseUp(button)
    if button == "LeftButton" then
        EA_Frame:StopMovingOrSizing();

		local point, _, _, xOfs, yOfs = EA_Frame:GetPoint();

        EA_Position.Anchor = point;
        EA_Position.xLoc = xOfs;
		EA_Position.yLoc = yOfs;
    end
end
